include std/machine.e
include std/dll.e
include EuSDL2.e
include EuSDL2_gfx.e
include funcs.e

object void
public integer fontWidth = 8, fontHeight = 8

public procedure design_button_side(atom ren, integer x1, integer y1, integer x2, integer y2, integer pushed)
  sequence tl, br  -- top left border color, bottom right border color
  if pushed then
    tl = {96, 96, 96}     -- dark gray
    br = {255, 255, 255}  -- white
  else
    tl = {255, 255, 255}  -- white
    br = {96, 96, 96}     -- dark gray
  end if
  -- draw button border
  for i = 0 to 2 do
    draw_lines(ren, {x1+i, y2-i+1, x1+i, y1+i, x2-i,   y1+i}, tl[1], tl[2], tl[3], 255)
    draw_lines(ren, {x2-i, y1+i+1, x2-i, y2-i, x1+i+1, y2-i}, br[1], br[2], br[3], 255)
  end for
end procedure

procedure design_button_face(atom ren, integer x1, integer y1, integer x2, integer y2)
  void = boxRGBA(ren, x1+3, y1+3, x2-2, y2-2, 160, 160, 160, 255)
end procedure

procedure design_button_text(atom ren, integer x1, integer y1, integer x2, integer y2, sequence text)
  integer spx = x2-x1-5-(length(text)*fontWidth)
  integer spy = y2-y1-5-fontHeight
  void = stringRGBA(ren, x1+4+floor(spx/2), y1+4+floor(spy/2), allocate_string(text), 0, 0, 0, 255)
end procedure

public procedure text_button(atom ren, integer x1, integer y1, integer x2, integer y2, sequence text, integer pushed)
  design_button_side(ren, x1, y1, x2, y2, pushed)
  design_button_face(ren, x1, y1, x2, y2)
  design_button_text(ren, x1, y1, x2, y2, text)
end procedure
