include std/machine.e
include EuSDL2.e

public procedure draw_rectangle(atom ren, integer x1, integer y1, integer x2, integer y2, integer r, integer g, integer b, integer a)
  SDL_SetRenderDrawColor(ren, r, g, b, a)
  atom rect = allocate(16)
  poke4(rect, {x1, y1, x2, y2})
  if SDL_RenderFillRect(ren, rect) < 0 then
    printf(2, "Error while filling rectangle: %s\n", SDL_GetError())
    SDL_Delay(2000)
    abort(0)
  end if
  free(rect)
end procedure

public procedure draw_lines(atom ren, sequence points, integer r, integer g, integer b, integer a)
  SDL_SetRenderDrawColor(ren, r, g, b, a)
  integer lg = length(points)/2
  atom c = allocate(lg*8)
  poke4(c, points)
  if SDL_RenderDrawLines(ren, c, lg) < 0 then
    printf(1, "Error while drawing lines: %s\n", SDL_GetError())
    SDL_Delay(2000)
    abort(0)
  end if
  free(c)
end procedure
