include std/machine.e
include ../Include/EuSDL2.e
include ../Include/EuSDL2_gfx.e

atom win, ren
object void

-- Entry point

  -- Initialize SDL's subsystems - in this case, only video.
  if (SDL_Init(SDL_INIT_EVERYTHING) < 0) then
    printf(2, "Unable to init SDL: %s\n", SDL_GetError())
    abort(1)
  end if

  win = SDL_CreateWindow("My Window - Press ESC to close",SDL_WINDOWPOS_CENTERED,SDL_WINDOWPOS_CENTERED,640,480,SDL_WINDOW_SHOWN)
  ren = SDL_CreateRenderer(win,-1,SDL_RENDERER_ACCELERATED)

  -- Main loop: loop forever.
atom run = 1
atom key = 0

while run = 1 do
  -- Clear window

  SDL_SetRenderDrawColor(ren, 0, 0, 0, 255)
  SDL_RenderClear(ren)

  -- Render stuff
  void = filledEllipseRGBA(ren, 100, 100, 64, 48, 0, 0, 255, 255)

  void = aatrigonRGBA(ren, 200, 200, 400, 200, 300, 300, 0, 255, 0, 255)

  atom vx = allocate(6*2)
  atom vy = allocate(6*2)
  poke2(vx, { 350, 275, 300, 325, 350, 400 })
  poke2(vy, { 325 , 325, 390, 390, 375, 300 })
  void = polygonRGBA(ren, vx, vy, 6, 255, 255, 255, 155)
  free(vx)
  free(vy)
  void = boxRGBA(ren, 100, 400, 160, 420, 160, 160, 160, 255)
  atom fontdata = allocate(GFX_FONTDATAMAX)
  poke(fontdata, gfxPrimitivesFontdata)
  gfxPrimitivesSetFont(fontdata, 8, 8)
  void = stringRGBA(ren, 100, 400, allocate_string("Texte"), 255, 255, 255, 155)
  free(fontdata)

  -- Poll for events, and handle the ones we care about.
  SDL_PumpEvents()
  key = SDL_GetKeyboardState(key)

  if (peek(key+SDL_SCANCODE_ESCAPE) > 0) then run = 0 end if

  -- update the screen
  SDL_RenderPresent(ren)

  -- don't take all the cpu time
  SDL_Delay(10)
end while

SDL_DestroyRenderer(ren)
SDL_DestroyWindow(win)
SDL_Quit()
