include std/machine.e
include ../Include/EuSDL2.e
include ../Include/EuSDL2_gfx.e
include ../Include/widgets.e

atom win, ren
object void

-- Mouse
atom mx,my
integer mouseX, mouseY
integer push_button, push_button2, toggle_button
atom run = 1

procedure onClick(integer i)
  sequence vc = registry[i]
  if vc[ID] = push_button then
    puts(1, "Click on push_button\n")
    run = 0
  elsif vc[ID] = push_button2 then
    puts(1, "Click on push_button2\n")
  elsif vc[ID] = toggle_button then
    puts(1, "Click on toggle_button\n")
  end if
end procedure

procedure onOver(integer i)
  sequence vc = registry[i]
  if vc[ID] = push_button then
    puts(1, "Over push_button\n")
  elsif vc[ID] = push_button2 then
    puts(1, "Over push_button2\n")
  elsif vc[ID] = toggle_button then
    puts(1, "Over toggle_button\n")
  end if
end procedure

procedure drawStaticItems()
  void = filledEllipseRGBA(ren, 100, 200, 64, 48, 0, 0, 255, 255)

  void = aatrigonRGBA(ren, 400, 200, 600, 200, 500, 300, 0, 255, 0, 255)

  atom vx = allocate(6*2)
  atom vy = allocate(6*2)
  poke2(vx, { 350, 275, 300, 325, 350, 400 })
  poke2(vy, { 325 , 325, 390, 390, 375, 300 })
  void = polygonRGBA(ren, vx, vy, 6, 255, 255, 255, 155)
  free(vx)
  free(vy)
  void = boxRGBA(ren, 436, 52, 564, 148, 255, 0, 0, 255)
  void = stringRGBA(ren, 100, 400, allocate_string("Texte"), 255, 255, 255, 255)
end procedure

-- Entry point

-- Initialize SDL's subsystems - in this case, only video.
if (SDL_Init(SDL_INIT_EVERYTHING) < 0) then
  printf(2, "Unable to init SDL: %s\n", SDL_GetError())
  abort(1)
end if

win = SDL_CreateWindow("My Window - Press ESC to close",SDL_WINDOWPOS_CENTERED,SDL_WINDOWPOS_CENTERED,640,480,SDL_WINDOW_SHOWN)
ren = SDL_CreateRenderer(win,-1,SDL_RENDERER_ACCELERATED)

push_button   = create_widget("Button",       10, 10, 110, 40, 0,                     routine_id("onOver"), {"Quit", 0})
push_button2  = create_widget("Button",      210, 10, 310, 40, routine_id("onClick"), routine_id("onOver"), {"OK", 0})
toggle_button = create_widget("ToggleButton", 10, 50, 110, 80, routine_id("onClick"), 0,                    {"Pushed", 1})
set_on_click_routine(push_button, routine_id("onClick"))
set_on_over_routine(toggle_button, routine_id("onOver"))

-- Main loop: loop forever.
mx=allocate(4)
my=allocate(4)

atom key = 0
integer gmouse = 0

while run = 1 do
  -- Clear window

  SDL_SetRenderDrawColor(ren, 0, 0, 0, 255)
  SDL_RenderClear(ren)

  -- Poll for events, and handle the ones we care about.
  SDL_PumpEvents()
  key = SDL_GetKeyboardState(key)

  if (peek(key+SDL_SCANCODE_ESCAPE) > 0) then run = 0 end if

  gmouse=SDL_GetMouseState(mx,my)
  if gmouse = -1 then
    puts(1, "SDL_GetMouseState had a hissy fit!\n")
  end if
  mouseX = peek(mx)+256*peek(mx+1)
  mouseY = peek(my)+256*peek(my+1)

  -- Draw static items
  drawStaticItems()

  -- Draw widgets
  draw_widgets(ren)

  -- Test if a widget is hit
  test_widget_hit(gmouse, mouseX, mouseY)

  -- update the screen
  SDL_RenderPresent(ren)

  -- don't take all the cpu time
  SDL_Delay(10)
end while

free(mx)
free(my)
SDL_DestroyRenderer(ren)
SDL_DestroyWindow(win)
SDL_Quit()
